function PWBAuraBar:OnInitialize()
	self.db = Protwarbar.db.profile.PWBAuraBar

	self.auraBars = {}
	self.auraCount = 0
	self.auraList = {}
	self.enabledAuraList = {}
	self.cdTable = {}
	PWBAuraBar:BuildGui()
end

function PWBAuraBar:OnEnable()
	self:RegisterEvent("UNIT_AURA")
	self:ScheduleRepeatingTimer("QuickTimer", 0.1)
end

function PWBAuraBar:ProfileChanged()
	self.db = Protwarbar.db.profile.PWBAuraBar
end

function PWBAuraBar:RefreshConfig()
	self.enabledAuraList = {}
	self.cdTable = {}

	for id, ability in pairs(self.auraList) do

		if self.db.auras[id] == nil then
			PWBAuraBar:InitNewAura(id)
		else
			if self.db.auras[id].enabled then
				PWBAuraBar:AddActiveAura(id)
			end
		end
	end

	PWBAuraBar:UpdateStyling()
	PWBAuraBar:UpdateVisiblity()
end

function PWBAuraBar:AddAura(ability, id)
	self.auraCount = self.auraCount + 1
	ability.name = GetSpellInfo(id)
	table.insert(self.auraList, id, ability)

	if self.db.auras[id] == nil then
		PWBAuraBar:InitNewAura(id)
	end

	if self.db.auras[id].enabled then
		PWBAuraBar:AddActiveAura(id)
	end
end

function PWBAuraBar:AddActiveAura(id)
	table.insert(self.enabledAuraList, id)
	table.insert(self.cdTable, id, {0, 0})
end

function PWBAuraBar:InitNewAura(id)
	self.db.auras[id] = {}
	self.db.auras[id].color = {1, 1, 1, 1}
	self.db.auras[id].enabled = false
end

function PWBAuraBar:UNIT_AURA(eventName, unit)
	if (unit == "player") then
		PWBAuraBar:UpdateAuraList()
		PWBAuraBar:Update()
	end
end

function PWBAuraBar:QuickTimer()
	PWBAuraBar:Update()
end

-- TODO: make an activeAuraTable, where we store the auras that are active on char, so we only have to check those
function PWBAuraBar:Update()
	local barVal = 0
	local barcount = 1
	local time = 0
	local now = GetTime()
	local color = {0, 0, 0 ,0}

	for id, abilityId in pairs(self.enabledAuraList) do
		if barcount <= self.db.barcount then
			if self.cdTable[abilityId][2] > now then
				time = self.cdTable[abilityId][2] - now
				self.auraBars[barcount]:SetValue(time / self.cdTable[abilityId][1] * 100)
				self.auraBars[barcount]:SetStatusBarColor(self.db.auras[abilityId].color[1], self.db.auras[abilityId].color[2], self.db.auras[abilityId].color[3], self.db.auras[abilityId].color[4])
				barcount = barcount + 1
			end
		end
	end

	for i = barcount, self.db.barcount do
		self.auraBars[i]:SetValue(0)
	end

end

-- TODO: make cd table named like: cdtable.duration, cdtable.end

function PWBAuraBar:UpdateAuraList()
	for id, abilityId in pairs(self.enabledAuraList) do
		e, d = PWBAuraBar:CheckShield(self.auraList[abilityId])

		self.cdTable[abilityId][1] = d
		self.cdTable[abilityId][2] = e
	end

end

function PWBAuraBar:CheckShield(ability)
	local n,_,_,_,_,d,e,_,_,_,id,_,_,val1,val2,val3 = UnitAura("player", ability.name, nil, "HELPFUL");

	if n then
		if d > 0 then
			return  e, d
		end
	end

	return 0, 0
end