function PWBInfo:OnInitialize()
	self.db = Protwarbar.db.profile.PWBInfo
	self.Vengeance_name = GetSpellInfo(93098)
	PWBInfo:BuildGui()
end

function PWBInfo:OnEnable()
	self:RegisterEvent("UNIT_POWER_FREQUENT")
end

function PWBInfo:ProfileChanged()
	self.db = Protwarbar.db.profile.PWBInfo
end

function PWBInfo:RefreshConfig()
	PWBInfo:UpdateStyling()
	PWBInfo:UpdateVisiblity()
end

function PWBInfo:UNIT_POWER_FREQUENT(eventName, unit, powerType)
	if (unit == "player") then
		PWBInfo:Update(UnitPower("player"))
	end
end

function PWBInfo:Update(power)
	local _, stamina, _, _ = UnitStat("player", 3); -- get stamina
	local _, strength, _, _ = UnitStat("player", 1); -- get strength
	local baseAP, posBuffAP, negBuffAP = UnitAttackPower("player"); --AP value

	local attackPowerSide = (baseAP + posBuffAP + negBuffAP - strength * 2) * 2;
	local part = max(attackPowerSide, stamina * 2.5)

	local shieldBarrierText = ""

	if self.db.shieldBarrier.enabled then
		if power > 19 then

			if power > 59 then
				shieldBarrierText = string.format("%.1fK", part / 1000)
			else
				shieldBarrierText = string.format("%.1fK", part * power / 60 / 1000)
			end

		end
	end

	local ventext = ""

	if self.db.vengeance.enabled then
		local n,_,_,_,_,_,_,_,_,_,id,_,_,val1,val2,val3 = UnitAura("player", self.Vengeance_name, nil, "HELPFUL");

		if n then
			local vengeance = val2 or 0

			if vengeance > 0 then
				ventext = string.format("%.1fK", vengeance / 1000)
			end
		end
	end

	local seperator = ""
	if self.db.vengeance.enabled and self.db.shieldBarrier.enabled then
		seperator = self.db.seperator
	end
	VengeanceText:SetText(ventext .. seperator .. shieldBarrierText)
end